'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _enzyme = require('enzyme');

var _enzyme2 = _interopRequireDefault(_enzyme);

var _enzymeAdapterReact = require('enzyme-adapter-react-16');

var _enzymeAdapterReact2 = _interopRequireDefault(_enzymeAdapterReact);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_enzyme2.default.configure({ adapter: new _enzymeAdapterReact2.default() });

it('renders correctly', function () {
  var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { org: 'XXXXX' }));
  var tree = component.toJSON();

  expect(tree).toMatchSnapshot();
});

it('should expect namespace to export', function () {
  var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { org: 'XXXXX', namespace: 'FullStory' }));

  expect((0, _index.getWindowFullStory)()).toBeDefined();
});

it('should not update', function () {
  var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { org: 'XXXXX' }));
  var instance = component.getInstance();
  var spy = jest.spyOn(instance, 'render');

  component.update(_react2.default.createElement(_index2.default, { org: 'YYYYY' }));
  expect(spy).not.toHaveBeenCalled();
});

it('should shutdown on unmount', function () {
  var component = _reactTestRenderer2.default.create(_react2.default.createElement(_index2.default, { org: 'XXXXX' }));
  var instance = component.getInstance();
  var spy = jest.spyOn(instance, 'componentWillUnmount');

  component.unmount();
  expect(spy).toHaveBeenCalled();
});